#include <iostream>
#include <vector>
using namespace std;
int xors(int x) {
    int r = 0;
    for (int i = 1; i * i <= x; i++) {
        if (x % i == 0) {
            r ^= i;
            if (i != x / i) {
                r ^= x / i;
            }
        }
    }
    return r;
}
int main(){
  int n,k,i,x;
  vector<int>del;
  cin>>n;
  cin>>k;
  for(i=0;i<k;i++){
    cin>>x;
    del.push_back(x);
  }
  for(i=0;i<k;i++){
    cout<<xors(del[i])<<" ";
  }
}